<?php
/************************************************************************
Access_user Class ver 1.50 -
Easy to use class to protect pages and register users

Copyright (C) 2004 - Olaf Lederer

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

_________________________________________________________________________
available at http://www.finalwebsites.com 
Comments & suggestions: http://www.finalwebsites.com/contact.php

*************************************************************************/

session_start();
error_reporting (E_ALL); // I use this only for testing
require("./db_config.php");

class Access_user {
	
	var $db_server = DB_SERVER;
	var $db_name = DB_NAME;
	var $db_user = DB_USER;
	var $db_password = DB_PASSWORD;
	var $table_name = "users";
	
	var $conn_str;
	
	var $user;
	var $user_pw;
	var $user_full_name;
	var $user_info;
	var $user_email;
	var $save_login = "no";
	var $cookie_name = "user"; // change this two vars 
	var $cookie_path = "/classes/"; // if you need...
	
	var $count_visit;
	
	var $id;
	var $language = "en"; // change this property to use messages in another language 
	var $the_msg;
	var $login_page;
	var $main_page;
	var $password_page;
	
	var $webmaster_mail = "scripting@finalwebsites.com"; // here should be your mail address 
	var $webmaster_name = "The webmaster"; // you can change this name if you like
	
	function Access_user() {
		$this->connect_db();
		$this->login_reader();
		$this->login_page = "login.php";
		$this->main_page = "example.php";
		$this->password_page = "activate_password.php"; // change these names to fit you application
	}	
	function check_user($pass) {
		switch ($pass) {
			case "new": 
			$sql = sprintf("SELECT COUNT(*) AS test FROM %s WHERE email = '%s' || login = '%s'", $this->table_name, $this->user_email, $this->user);
			break;
			case "lost":
			$sql = sprintf("SELECT COUNT(*) AS test FROM %s WHERE email = '%s' AND active = 'y'", $this->table_name, $this->user_email);
			break;
			case "new_pass":
			$sql = sprintf("SELECT COUNT(*) AS test FROM %s WHERE pw = '%s' AND active = 'y'", $this->table_name, $this->user_pw);
			break;
			case "active":
			$sql = sprintf("SELECT COUNT(*) AS test FROM %s WHERE id = %s AND active = 'n'", $this->table_name, $this->id);
			break;
			case "validate":
			$sql = sprintf("SELECT COUNT(*) AS test FROM %s WHERE id = %s AND tmp_mail <> ''", $this->table_name, $this->id);
			break;
			default:
			$pass = (strlen($pass) < 32) ? md5($pass) : $pass;
			$sql = sprintf("SELECT COUNT(*) AS test FROM %s WHERE login = '%s' AND pw = '%s' AND active = 'y'", $this->table_name, $this->user, $pass);
		}
		$result = mysql_query($sql);
		if (mysql_result($result, 0, "test") == 1) {
			return true;
		} else {
			return false;
		}
	}
	function set_user() {
		$_SESSION['user'] = $this->user;
		$_SESSION['pw'] = $this->user_pw;
		if (isset($_SESSION['referer']) && $_SESSION['referer'] != "") {
			$next_page = $_SESSION['referer'];
			unset($_SESSION['referer']);
		} else {
			$next_page = $this->main_page;
		}
		header("Location: ".$next_page);
	}
	function connect_db() {
		$this->conn_str = mysql_connect($this->db_server, $this->db_user, $this->db_password);
		mysql_select_db($this->db_name, $this->conn_str);
	}
	function login_user($user, $password) {
		if ($user != "" && $password != "") {
			$this->user = $user;
			$this->user_pw = $password;
			if ($this->check_user($this->user_pw)) {
				if ($this->save_login == "yes") {
					$this->login_saver();
				}
				if ($this->count_visit) {
					$this->reg_visit($user, $password);
				}
				$this->set_user();
			} else {
				$this->the_msg = $this->messages(10);
			}
		} else {
			$this->the_msg = $this->messages(11);
		}
	}
	function login_saver() {
		$cookie_str = $this->user.chr(31).base64_encode($this->user_pw);
		setcookie($this->cookie_name, $cookie_str, time()+2592000, $this->cookie_path);
	}
	function remove_cookie() {
		// remove here: comes next!
	}
	function check_cookie() {
		// check here: comes next!
	}
	function login_reader() {
		if (isset($_COOKIE[$this->cookie_name])) {
			$cookie_parts = explode(chr(31), $_COOKIE[$this->cookie_name]);
			$this->user = $cookie_parts[0];
			$this->user_pw = base64_decode($cookie_parts[1]);
		}
	}
	function reg_visit($login, $pass) {
		$visit_sql = sprintf("UPDATE users SET extra_info = '%s' WHERE login = '%s' AND pw = '%s'", date("Y-m-d H:i:s"), $login, md5($pass));
		mysql_query($visit_sql);
	}
	function log_out() {
		unset($_SESSION['user']);
		unset($_SESSION['pw']);
		header("Location: ".$this->login_page);
	}
	function access_page($refer = "", $qs = "") {
		$refer_qs = $refer;
		$refer_qs .= ($qs != "") ? "?".$qs : "";
		if (isset($_SESSION['user']) && isset($_SESSION['pw'])) {
			$this->user = $_SESSION['user'];
			$this->user_pw = $_SESSION['pw'];
			if (!$this->check_user($this->user_pw)) {
				$_SESSION['referer'] = $refer_qs;
				header("Location: ".$this->login_page);
			}
		} else { 
			$_SESSION['referer'] = $refer_qs;
			header("Location: ".$this->login_page);
		}
	}
	function get_user_info() {
		$sql_info = sprintf("SELECT real_name, extra_info, email, id FROM %s WHERE login = '%s' AND pw = '%s'", $this->table_name, $this->user, md5($this->user_pw));
		$res_info = mysql_query($sql_info);
		$this->id = mysql_result($res_info, 0, "id");
		$this->user_full_name = mysql_result($res_info, 0, "real_name");
		$this->user_info = mysql_result($res_info, 0, "extra_info");
		$this->user_email = mysql_result($res_info, 0, "email");
	}
	function update_user($new_password, $new_name, $new_info, $new_mail) {
		if ($new_password != "") {
			if (strlen($new_password) < 4) {
				$this->the_msg = $this->messages(32);
				return;
			} else {
				$ins_password = md5($new_password);
				$update_pw = true;
			}
		} else {
			$ins_password = md5($this->user_pw);
			$update_pw = false;
		}
		if (trim($new_mail) <> $this->user_email) {
			if  ($this->check_email($new_mail)) {
				$this->user_email = $new_mail;
				if (!$this->check_user("lost")) {
					$update_email = true;
				} else {
					$this->the_msg = $this->messages(31);
					return;
				}
			} else {
				$this->the_msg = $this->messages(16);
				return;
			}
		} else {
			$update_email = false;
			$new_mail = "";
		}
		$upd_sql = sprintf("UPDATE %s SET pw = %s, real_name = %s, extra_info = %s, tmp_mail = %s WHERE id = %s", 
			$this->table_name,
			$this->ins_string($ins_password),
			$this->ins_string($new_name),
			$this->ins_string($new_info),
			$this->ins_string($new_mail),
			$this->id);
		$upd_res = mysql_query($upd_sql);
		if ($upd_res) {
			if ($update_pw) {
				$_SESSION['pw'] = $ins_password;
			}
			$this->the_msg = $this->messages(30);
			if ($update_email) {
				if ($this->send_mail($new_mail, 33)) {
					$this->the_msg = $this->messages(27);
				} else {
					mysql_query(sprintf("UPDATE %s SET tmp_mail = ''",$this->table_name));
					$this->the_msg = $this->messages(14);
				} 
			}
		} else {
			$this->the_msg = $this->messages(15);
		}
	}
	function check_email($mail_address) {
		if (preg_match("/[a-z0-9_-]+(\.[a-z0-9_-]+)*@([0-9a-z][0-9a-z-]*[0-9a-z]\.)+([a-z]{2,4})/i", $mail_address)) {
			return true;
		} else {
			return false;
		}
	}
	function ins_string($value) {
		$value = (!get_magic_quotes_gpc()) ? addslashes($value) : $value;
		$value = ($value != "") ? "'" . $value . "'" : "''";
		return $value;
	}
	function register_user($first_login, $first_password, $first_name, $first_info, $first_email) {
		if (strlen($first_login) >= 6 && strlen($first_password) >= 4) {
			if ($this->check_email($first_email)) {
				$this->user_email = $first_email;
				$this->user = $first_login;
				if ($this->check_user("new")) {
					$this->the_msg = $this->messages(12);
				} else {
					$sql = sprintf("INSERT INTO %s (id, login, pw, real_name, extra_info, email, active) VALUES (NULL, %s, %s, %s, %s, %s, 'n')", 
						$this->table_name,
						$this->ins_string($first_login),
						$this->ins_string(md5($first_password)),
						$this->ins_string($first_name),
						$this->ins_string($first_info),
						$this->ins_string($this->user_email));
					$ins_res = mysql_query($sql);
					if ($ins_res) {
						$this->id = mysql_insert_id();
						$this->user_pw = $first_password;
						if ($this->send_mail($this->user_email)) {
							$this->the_msg = $this->messages(13);
						} else {
							mysql_query(sprintf("DELETE FROM %s WHERE id = %s", $this->table_name, $this->id));
							$this->the_msg = $this->messages(14);
						}
					} else {
						$this->the_msg = $this->messages(15);
					}
				}
			} else {
				$this->the_msg = $this->messages(16);
			}
		} else {
			$this->the_msg = $this->messages(17);
		}
	}
	function validate_email($validation_key, $key_id) {
		if ($validation_key != "" && strlen($validation_key) == 32 && $key_id > 0) {
			$this->id = $key_id;
			if ($this->check_user("validate")) {
				$upd_sql = sprintf("UPDATE %s SET email = tmp_mail, tmp_mail = '' WHERE id = %s AND pw = '%s'", $this->table_name, $key_id, $validation_key);
				if (mysql_query($upd_sql)) {
					$this->the_msg = $this->messages(18);
				} else {
					$this->the_msg = $this->messages(19);
				}
			} else {
				$this->the_msg = $this->messages(34);
			}
		} else {
			$this->the_msg = $this->messages(21);
		}
	}
	function activate_account($activate_key, $key_id) {
		if ($activate_key != "" && strlen($activate_key) == 32 && $key_id > 0) {
			$this->id = $key_id;
			if ($this->check_user("active")) {
				$upd_sql = sprintf("UPDATE %s SET active = 'y' WHERE id = %s AND pw = '%s'", $this->table_name, $key_id, $activate_key);
				if (mysql_query($upd_sql)) {
					$this->the_msg = $this->messages(18);
				} else {
					$this->the_msg = $this->messages(19);
				}
			} else {
				$this->the_msg = $this->messages(20);
			}
		} else {
			$this->the_msg = $this->messages(21);
		}
	}
	function send_mail($mail_address, $num = 29) {
		$header = "From: \"".$this->webmaster_mail."\" <".$this->webmaster_name.">\r\n";
		$header .= "MIME-Version: 1.0\r\n";
		$header .= "Mailer: Olaf's mail program version 1.10\r\n";
		$header .= "Content-Type: text/plain; charset=\"iso-8859-1\"\r\n";
		$header .= "Content-Transfer-Encoding: 8bit\r\n";
		$subject = $this->messages(28);
		$body = $this->messages($num);
		if (mail($mail_address, $subject, $body, $header)) {
			return true;
		} else {
			return false;
		} 
	}
	function forgot_password($forgot_email) { 
		if ($this->check_email($forgot_email)) {
			$this->user_email = $forgot_email;
			if (!$this->check_user("lost")) {
				$this->the_msg = $this->messages(22);
			} else {
				$forgot_sql = sprintf("SELECT id, pw FROM %s WHERE email = '%s'", $this->table_name, $this->user_email);
				if ($forgot_result = mysql_query($forgot_sql)) {
					$this->id = mysql_result($forgot_result, 0, "id");
					$this->user_pw = mysql_result($forgot_result, 0, "pw");
					if ($this->send_mail($this->user_email, 35)) {
						$this->the_msg = $this->messages(23);
					} else {
							$this->the_msg = $this->messages(14);
					}
				} else {
					$this->the_msg = $this->messages(15);
				}
			}
		} else {
			$this->the_msg = $this->messages(26);
		}
	}
	function check_activation_password($controle_str, $id) {
		if ($controle_str != "" && strlen($controle_str) == 32 && $id > 0) {
			$this->user_pw = $controle_str;
			if ($this->check_user("new_pass")) {
				$check_result = mysql_query(sprintf("SELECT login FROM %s WHERE id = %s", $this->table_name, $id));
				$this->user = mysql_result($check_result, 0, "login");
				return true;
			} else {
				$this->the_msg = $this->messages(21);
				return false;
			}
		} else {
			$this->the_msg = $this->messages(21);
			return false;
		}
	}
	function activate_new_password($new_pass, $old_pass) {
		if (strlen($new_pass) >= 4) {
			$sql_new_pass = sprintf("UPDATE %s SET pw = '%s' WHERE pw = '%s'", $this->table_name, md5($new_pass), $old_pass);
			if (mysql_query($sql_new_pass)) {
				$this->the_msg = $this->messages(30);
			} else {
				$this->the_msg = $this->messages(14);
			}
		} else {
			$this->the_msg = $this->messages(32);
		}
	}
	function messages($num) {
		global $HTTP_HOST, $PHP_SELF;
		switch ($this->language) {
			case "de":
			$msg[10] = "Login und/oder Passwort finden keinen Treffer in der Datenbank.";
			$msg[11] = "Login und/oder Passwort sind leer!";
			$msg[12] = "Leider existiert bereits ein Benutzer mit diesem Login und/oder E-mailadresse. ";
			$msg[13] = "Kontrollieren Sie nun Ihre E-Mail und folgen Sie den Instruktionen.";
			$msg[14] = "Es is ein Fehler entstanden probieren Sie es erneut.";
			$msg[15] = "Es is ein Fehler entstanden probieren Sie es spter nochmal.";
			$msg[16] = "Die eingegebene E-mailadresse ist nicht gltig.";
			$msg[17] = "Das Feld login (min. 6 Zeichen) <br>und das Passwort (min. 4 Zeichen) mssen eingegeben sein.";
			$msg[18] = "Ihr Benutzerkonto ist aktiv. Sie knnen sich nun anmelden.";
			$msg[19] = "Ihr Aktivierungs ist nicht gltig.";
			$msg[20] = "Da ist kein Konto zu aktivieren.";
			$msg[21] = "Der benutzte Aktivierung-Code is nicht gltig!";
			$msg[22] = "Keine Konto gefunden dass mit der eingegeben E-mailadresse bereinkommt.";
			$msg[23] = "Kontrollieren Sie Ihre E-Mail um Ihr neues Passwort zu erhalten.";
			$msg[25] = "Kann Ihr Passwort nicht aktivieren.";
			$msg[26] = "Die Felder E-mail und/oder Passwort sind nicht gltig, <br>Bitte geben Sie eine gltige E-mailadresse und Passwort (min. 4 Zeichen) ein.";
			$msg[27] = "Kontrollieren Sie Ihre E-Mail und besttigen Sie Ihre nderung(en).";
			$msg[28] = "Ihre Anfrage ist in Bearbeitung...";
			$msg[29] = "Hallo,\r\n\r\num Ihre Anfrage zu aktivieren klicken Sie bitte auf den folgenden link:\r\nhttp://".$HTTP_HOST.dirname($PHP_SELF)."/".$this->login_page."?ident=".$this->id."&activate=".md5($this->user_pw);
			$msg[30] = "Ihre nderung ist durchgefhrt.";
			$msg[31] = "Diese E-mailadresse wird bereits genutzt, bitte whlen Sie eine andere.";
			$msg[32] = "Das Feld Passwort (min. 4 Zeichen) muss eingegeben sein.";
			$msg[33] = "Hallo,\r\n\r\nIhre neu E-mailadresse muss noch berprft werden, bitte klicken Sie auf den folgenden link:\r\nhttp://".$HTTP_HOST.dirname($PHP_SELF)."/".$this->login_page."?id=".$this->id."&validate=".md5($this->user_pw);
			$msg[34] = "Da ist keine E-mailadresse zu berprfen.";
			$msg[35] = "Hallo,\r\n\r\nIhr neues Passwort kann nun eingegeben werden, bitte klicken Sie auf den folgenden link:\r\nhttp://".$HTTP_HOST.dirname($PHP_SELF)."/".$this->password_page."?id=".$this->id."&activate=".$this->user_pw;
			break;
			case "nl":
			$msg[10] = "Gebruikersnaam en/of wachtwoord vinden geen overeenkomst in de database.";
			$msg[11] = "Gebruikersnaam en/of wachtwoord zijn leeg!";
			$msg[12] = "Helaas bestaat al een gebruiker met dit gebruikersnaam en/of e-mail adres.";
			$msg[13] = "Controleer nu uw email en volg de instructies.";
			$msg[14] = "Het is een fout ontstaan, probeer het opnieuw.";
			$msg[15] = "Het is een fout ontstaan, probeer het later nog een keer.";
			$msg[16] = "De opgegeven e-mail adres is niet geldig.";
			$msg[17] = "De velden gebruikersnaam (min. 6 teken) <br>en wachtwoord (min. 4 teken) moeten opgegeven zijn.";
			$msg[18] = "Het gebruikersaccount is klaar. Meld je nu aan.";
			$msg[19] = "Kan uw account niet activeren.";
			$msg[20] = "Er is geen account te activeren.";
			$msg[21] = "De gebruikte activeringscode is niet geldig!";
			$msg[22] = "Geen account gevonden dat met de opgegeven e-mail adres overeenkomt.";
			$msg[23] = "Controleer uw e-mail om een nieuw wachtwoord te ontvangen.";
			$msg[25] = "Kan het wachtwoord niet activeren.";
			$msg[26] = "De velden e-mail en/of wachtwoord zijn niet geldig, <br>geef een geldig e-mail adres en wachtwoord (min. 4 teken) op.";
			$msg[27] = "Controleer  je mail en bevestig je wijziging(en).";
			$msg[28] = "Je aanvraag is in bewerking...";
			$msg[29] = "Hallo,\r\n\r\nklik op de volgende link om de aanvraag te verwerken:\r\nhttp://".$HTTP_HOST.dirname($PHP_SELF)."/".$this->login_page."?ident=".$this->id."&activate=".md5($this->user_pw);
			$msg[30] = "Je wijzigingen zijn doorgevoerd.";
			$msg[31] = "Deze e-mailadres bestaat al, gebruik en andere.";
			$msg[32] = "Het veld wachtwoord (min. 4 teken) moet opgegeven zijn.";
			$msg[33] = "Hallo,\r\n\r\nde nieuwe e-mailadres moet nog valideert worden, klik hiervoor op de volgende link:\r\nhttp://".$HTTP_HOST.dirname($PHP_SELF)."/".$this->login_page."?id=".$this->id."&validate=".md5($this->user_pw);
			$msg[34] = "Er is geen e-mailadres te valideren.";
			$msg[35] = "Hallo,\r\n\r\nUw nieuw wachtwoord kan nu ingevoerd worden, klik op deze link om verder te gaan:\r\nhttp://".$HTTP_HOST.dirname($PHP_SELF)."/".$this->password_page."?id=".$this->id."&activate=".$this->user_pw;
			break;
			default:
			$msg[10] = "Login and/or password did not match to the database.";
			$msg[11] = "Login and/or password is empty!";
			$msg[12] = "Sorry, a user with this login and/or e-mail address already exist.";
			$msg[13] = "Please check your e-mail and follow the instructions.";
			$msg[14] = "Sorry, an error occurred please try it again.";
			$msg[15] = "Sorry, an error occurred please try it again later.";
			$msg[16] = "The e-mail address is not valid.";
			$msg[17] = "The fields login (min. 6 char.) <br>and password (min. 4 char) are required.";
			$msg[18] = "Your request is processed. Login to continue.";
			$msg[19] = "Sorry, cannot activate your account.";
			$msg[20] = "There is no account to activate.";
			$msg[21] = "Sorry, this activation key is not valid!";
			$msg[22] = "Sorry, there is no active account which match with this e-mail address.";
			$msg[23] = "Please check your e-mail to get your new password.";
			$msg[25] = "Sorry, cannot activate your password.";
			$msg[26] = "The field e-mail and/or password are not valid, <br>please enter a valid e-mail address and password (min. 4 char)";
			$msg[27] = "Please check your e-mail and activate your modifikation(s).";
			$msg[28] = "Your request must be processed...";
			$msg[29] = "Hallo,\r\n\r\nto activate your request click the following link:\r\nhttp://".$HTTP_HOST.dirname($PHP_SELF)."/".$this->login_page."?ident=".$this->id."&activate=".md5($this->user_pw);
			$msg[30] = "Your account is modified.";
			$msg[31] = "This e-mail address already exist, please use another one.";
			$msg[32] = "The field password (min. 4 char) is required.";
			$msg[33] = "Hallo,\r\n\r\nthe new e-mail address must be validated, click the following link:\r\nhttp://".$HTTP_HOST.dirname($PHP_SELF)."/".$this->login_page."?id=".$this->id."&validate=".md5($this->user_pw);
			$msg[34] = "There is no e-mail address for validation.";
			$msg[35] = "Hallo,\r\n\r\nEnter your new password next, please click the following to enter the form:\r\nhttp://".$HTTP_HOST.dirname($PHP_SELF)."/".$this->password_page."?id=".$this->id."&activate=".$this->user_pw;
		}
		return $msg[$num];
	}
}
?>